"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.toSwagger = exports.main = void 0;
const fs_1 = __importDefault(require("fs"));
const apidoc_light_1 = __importDefault(require("apidoc-light"));
const apidoc_to_swagger_1 = require("./apidoc_to_swagger");
Object.defineProperty(exports, "toSwagger", { enumerable: true, get: function () { return apidoc_to_swagger_1.toSwagger; } });
function main(options) {
    options.verbose && console.log('options', options);
    if (!options.src) {
        throw new Error('`cli.input` is required but was not provided.');
    }
    if (!options.output) {
        throw new Error('`cli.output` is required but was not provided.');
    }
    const { data, project } = apidoc_light_1.default.createDoc(Object.assign(Object.assign({}, options), { dryRun: true }));
    const swagger = (0, apidoc_to_swagger_1.toSwagger)(data.filter((x) => x.type), project);
    createOutputFile(JSON.stringify(swagger), options);
    return swagger;
}
exports.main = main;
function createOutputFile(swaggerData, options) {
    console.log('create dir: ' + options.output);
    if (!options.dryRun) {
        fs_1.default.existsSync(options.output) || fs_1.default.mkdirSync(options.output);
    }
    //Write swagger
    console.log('write swagger json file: ' + options.output + 'swagger.json');
    if (!options.dryRun) {
        fs_1.default.writeFileSync(options.output + './swagger.json', swaggerData);
    }
}
